/*
	test on: // N	//fb.dat % 4039	//gowalla.dat % 196591
 */
/* NAME   : nodeRank.cpp
 *	AUTHOR : Arjun Krishna
 */
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <list>
#include <map>

using namespace std;

//functions defined

int ceil(float x)
{
	int X = x;
	if((x-X) > 0.5)
		return (X+1);
	else
		return (X);
}

// Classes defined
class Graph
{
	int V;
	int * deg;
	list <int> *adjList;
	int maxRank;
	int * nodeRank;
	
	public:
	Graph(int V,char* fname)
	{
		this->V = V;
		adjList = new list<int> [V];
		nodeRank = (int*) malloc(sizeof(int)*V);
		//fnodeRank = (float*) malloc(sizeof(float)*V);
		for(int i=0;i<V;i++)
			nodeRank[i] = 0;
		deg = (int*) malloc(sizeof(int)*V);
		for(int i=0;i<V;i++)
			deg[i] = 0; 
		readGraph(fname);
		maxRank = 0;
	}
	void readGraph(char* fname)
	{
		int a,b;
		ifstream fin;
		fin.open(fname);
		while(fin>>a>>b)
		{
			adjList[a].push_back(b);
			adjList[b].push_back(a);
			deg[a]++;
			deg[b]++;
		}
		fin.close();
	}
	void node_Rank(int max_itr,float tel)  // NODE RANK ( A RANDOM WALK)
	{
		int temp = max_itr;
		list <int>::iterator itr;
		int s;
		int curr_node = 0;
		while(max_itr--)
		{
			if(node_option(tel)) //walk
			{
				if(adjList[curr_node].empty()) //Teleport
				{
					s = rand()%V;
					curr_node = s;
					nodeRank[curr_node]++;
					if(nodeRank[curr_node] > maxRank) maxRank = nodeRank[curr_node];
				}
				else
				{
					s = rand()%((int) adjList[curr_node].size());
					itr = adjList[curr_node].begin();
					while(s--)
					{
						itr++;
					}
					curr_node = *itr;
					nodeRank[curr_node]++;
					if(nodeRank[curr_node] > maxRank) maxRank = nodeRank[curr_node];					
				}
			}
			else		//Teleport
			{
				s = rand()%V;
				curr_node = s;
				nodeRank[curr_node]++;
				if(nodeRank[curr_node] > maxRank) maxRank = nodeRank[curr_node];
			}
		}
	}
	int node_option(float tel) //teleport freq = (0 to 1) // To decide to Teleport or walk along its edges
	{
		int p;
		int T = tel*100;
		p = rand()%100;
		if(p>T)
			return 1; // option to walk
		else
			return 0; // Teleport
	}
	void printRank()
	{
		for(int i=0;i<V;i++)
			cout<<i<<","<< nodeRank[i]<<","<< deg[i] <<endl; //int rank printed
	}
};

int main(int argc,char*argv[])
{
	if(argc!=3) { cout << "Usage : ./a.out filename N"<<endl; return 0; }
	int N = atoi(argv[2]);		
	Graph G(N,argv[1]);
	G.node_Rank(4*N,0.10);
	G.printRank();	
	
	return 0;
}
